set linesize 32000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set echo on
set termout on
set trimspool on
set serveroutput on size 1000000
set timing on

spool appendvalues.log

select * from v$version;

-- regular insert with values clause
-- no hint

drop table test;

create table test (coll number);

DECLARE
  TYPE NumList IS TABLE OF NUMBER INDEX BY PLS_INTEGER;
  testlist NumList;
BEGIN

  FOR j IN 1..10000 LOOP
    testlist(j) := j;
  END LOOP;
  
  FOR k IN 1..1000 LOOP

    FORALL i IN 1..10000
      INSERT
      INTO test
      VALUES (testlist(i));
      
    commit;
    
  END LOOP;

END;
/

select count(*) from test;

-- insert with values clause
-- with append_values hint

drop table test;

create table test (coll number);

DECLARE
  TYPE NumList IS TABLE OF NUMBER INDEX BY PLS_INTEGER;
  testlist NumList;
BEGIN

  FOR j IN 1..10000 LOOP
    testlist(j) := j;
  END LOOP;
  
  FOR k IN 1..1000 LOOP

    FORALL i IN 1..10000
      INSERT /*+ append_values */
      INTO test
      VALUES (testlist(i));
      
    commit;
    
  END LOOP;

END;
/

select count(*) from test;

spool off
