set linesize 32000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set echo on
set termout on
set trimspool on
set serveroutput on size 1000000
set timing on

spool appendvalues2.log

-- regular insert with values clause
-- no hint

drop table test;

create table test (coll number);

BEGIN

  FOR k IN 1..10 LOOP
    FOR j IN 1..10000 LOOP
      INSERT INTO test VALUES (1);
    END LOOP;
    commit;
  END LOOP;
END;
/

select count(*) from test;

-- insert with values clause
-- with append_values hint

drop table test;

create table test (coll number);

BEGIN

  FOR k IN 1..10 LOOP
    FOR j IN 1..10000 LOOP
      INSERT /*+append_values */ INTO test VALUES (1);
    END LOOP;
    commit;
  END LOOP;
END;
/

select count(*) from test;

spool off
